%define ALD_Ver		1.2.1

Name:         kbd

License:      GPL
Summary:      GPL Copyright (C) 1992 Rickard E. Faith.
Group:        System/Tools
Version:      1.15.3
Release:      1
URL: ftp://ftp.altlinux.org/pub/people/legion/kbd/

Source: %{name}-%{version}.tar.xz
Source1: CROSS.sh

%define DestDir		/System

# -----------------------------------------------------
%if %{_target_cpu} == %{_build_cpu}
%define _CROSS 0
%else
# rpm --target=x86_64/armv6l/win32 -ba xxxxx.spec
%define _CROSS 1
%endif

%define TO_ARCH %{_target_cpu}

%if %{_target_cpu} == "armv6l"
%define ARM_ARCH armv6zk
%define ARM_FPU  -mfpu=vfp -mfloat-abi=hard
%define TO_ARCH %{ARM_ARCH}
%endif

%if %{_target_cpu} == "armv7l"
%define ARM_ARCH armv7-a
%define ARM_FPU  -mfpu=vfpv3-d16 -mfloat-abi=hard
%define TO_ARCH %{ARM_ARCH}
%endif

%define BUILD_TAR 1
#------------------ CROSS DIR --------------------
%if %{_CROSS}

%if %{_os} == "mingw"
ERROR: target=%{_os}
%define target %{_arch}-%{_vendor}-%{_os}%{__isa_bits}
%else  #win32 || win64
%define target %{_arch}-%{_os}%{_gnu}
%endif
%define target_  %{target}-

%define crossdir	/cross
%if %{_arch} == "arm"
%define csysdir		%{crossdir}/%{ARM_ARCH}
%else
%define csysdir		%{crossdir}/%{_target_cpu}
%endif
%define csysbindir	%{csysdir}/bin

%define __os_install_post %{nil}

%define _srcrpmdir	%{_topdir}/SRPMS/tmp

%else  #_CROSS

%define csysbindir	%{_prefix}/bin
%define _srcrpmdir	%{_topdir}/SRPMS/%{ALD_Ver}

%define target_  %{nil}
%define target %{_build}

%endif # !_CROSS

%define docdir %{_defaultdocdir}/%{name}
%define _libexecdir %{_sbindir}

# ------------------- description ------------------------------------
%description
This package provide fixes in the kernel (console.c, keydoard.c and vt.c),
setfont and mapscrn utilities, and fixes to the loadkey utility.
setfont loads custom EGA/VGA fonts, mapscrn specifies screen output mapping,
and loadkeys with this fixes provides "AltGr-Lock" state of the keyboard,
and makes possible to specify which characters are alphabetic and therefore
should be affected by the CapsLock.
#-------------------------------
%package all
Summary:      The kbd packages all files
Group:        System/Tools
Requires: %{name}
%description all
The kbd packages all files
#-------------------------------
%package doc
Summary:      doc for %{name}
Group:        Documentation
%description doc
doc for %{name}

# ------------------- setup ------------------------------------------
%Prep
%setup -q -n %{name}-%{version}

# ------------------- Build ------------------------------------------
%Build
%if %{_CROSS}
PATH=%{csysbindir}:$PATH:/opt/perl/bin
GCC_NoHostPath=d
export PATH GCC_NoHostPath
%else
export PATH=$PATH:/opt/perl/bin
%endif

%if %{_arch} == "i386"
OPTFLAGS="-Os -march=i486 -mpreferred-stack-boundary=2 -falign-functions=1 -falign-jumps=1 -falign-loops=1 -fomit-frame-pointer"
%endif
%if %{_arch} == "x86_64"
OPTFLAGS="-Os -fno-asynchronous-unwind-tables"
%endif
%if %{_arch} == "arm"
OPTFLAGS="-Os -march=%{ARM_ARCH} %{ARM_FPU} -munaligned-access"
%endif

CFLAGS="$OPTFLAGS -ffunction-sections -fdata-sections"
LDFLAGS="-Wl,--gc-sections"

%configure \
	--build=%{_build} \
%if %{_CROSS}
	--host=%{target} \
%endif
	--disable-nls \
	--disable-rpath \
	&>FConfigure_log.txt

make V=1 &>FMake_log.txt

# ------------------- Install ----------------------------------------
%Install
PATH=%{csysbindir}:$PATH:/opt/perl/bin
GCC_NoHostPath=d
export PATH GCC_NoHostPath

rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
mkdir -p %{_srcrpmdir}
mkdir -p $RPM_BUILD_ROOT%{docdir}/html

make DESTDIR=$RPM_BUILD_ROOT install &>FInstall_log.txt

cp -r doc/* $RPM_BUILD_ROOT%{docdir}/html/
cp AUTHORS COPYING CREDITS README $RPM_BUILD_ROOT%{docdir}/

%if %{_CROSS}
TARGET_PRFIX=%{_prefix}
TARGET_CROSS_PRFIX=%{csysdir}
TARGET_NAME=%{target}
MKCROSSDIR=0
export TARGET_PRFIX TARGET_CROSS_PRFIX TARGET_NAME MKCROSSDIR
%SOURCE1
%endif #_CROSS

%if !%{_CROSS}
if test -f /opt/aldccp/bin/packages_idx; then
  /opt/aldccp/bin/packages_idx -p %{name} -v %{version} $RPM_BUILD_ROOT
fi
%endif

# ------------------- Clean ------------------------------------------
%Clean 

DE=%{version}-%{release}.%{TO_ARCH}.rpm
DD=%{_rpmdir}/%{TO_ARCH}/%{ALD_Ver}%{DestDir}

pushd %{_rpmdir}/%{_target_cpu}
  SE=%{version}-%{release}.%{_target_cpu}.rpm
  mkdir -p $DD
  mv %{name}-$SE $DD/%{name}-$DE
  mv %{name}-all-$SE $DD/%{name}-all-$DE
  mv %{name}-doc-$SE $DD/%{name}-doc-$DE
popd

# --------------- build *.tgz ------------------------
%if %{BUILD_TAR}
pushd $RPM_BUILD_ROOT
  TMP_TO=$DD/tar
  mkdir -p $TMP_TO
  tmp=%{name}-%{version}-%{release}.%{TO_ARCH}
  mkdir -p $tmp
  cp -r usr $tmp/
  tar -cjf $tmp.tar.bz2 $tmp
  mv $tmp.tar.bz2 $TMP_TO
  rm -r $tmp
popd
%endif  #BUILD_TAR

# ------------------- Files ------------------------------------------
%Files
%{_bindir}/setfont
%{_bindir}/setkeycodes
%{_bindir}/loadkeys
%{_datadir}/consolefonts/alt-8x8.gz
%{_datadir}/consolefonts/alt-8x14.gz
%{_datadir}/consolefonts/lat1-08.psfu.gz
%{_datadir}/consolefonts/lat1-10.psfu.gz
%{_datadir}/consolefonts/lat1-12.psfu.gz
%{_datadir}/keymaps/i386/azerty/azerty.map.gz
%{_datadir}/keymaps/i386/azerty/fr-latin1.map.gz
%{_datadir}/keymaps/i386/qwerty/it2.map.gz
%{_datadir}/keymaps/i386/qwerty/nl2.map.gz
%{_datadir}/keymaps/i386/qwerty/us.map.gz
%{_datadir}/keymaps/i386/qwertz/de-latin1-nodeadkeys.map.gz
%{_datadir}/keymaps/i386/qwertz/de-latin1.map.gz
%{_datadir}/keymaps/i386/qwertz/de.map.gz
%{_datadir}/keymaps/i386/include
%{_datadir}/keymaps/include
%{_mandir}/man1/loadkeys.1.gz
%{_mandir}/man8/setkeycodes.8.gz
%{_mandir}/man8/setfont.8.gz
%{docdir}/AUTHORS
%{docdir}/COPYING 
%{docdir}/CREDITS 
%{docdir}/README

%Files all
%{_bindir}
%exclude %{_bindir}/setfont
%exclude %{_bindir}/setkeycodes
%exclude %{_bindir}/loadkeys
%{_datadir}/consolefonts
%exclude %{_datadir}/consolefonts/alt-8x8.gz
%exclude %{_datadir}/consolefonts/alt-8x14.gz
%exclude %{_datadir}/consolefonts/lat1-08.psfu.gz
%exclude %{_datadir}/consolefonts/lat1-10.psfu.gz
%exclude %{_datadir}/consolefonts/lat1-12.psfu.gz
%{_datadir}/consoletrans
%{_datadir}/keymaps
%exclude %{_datadir}/keymaps/i386/azerty/azerty.map.gz
%exclude %{_datadir}/keymaps/i386/azerty/fr-latin1.map.gz
%exclude %{_datadir}/keymaps/i386/qwerty/it2.map.gz
%exclude %{_datadir}/keymaps/i386/qwerty/nl2.map.gz
%exclude %{_datadir}/keymaps/i386/qwerty/us.map.gz
%exclude %{_datadir}/keymaps/i386/qwertz/de-latin1-nodeadkeys.map.gz
%exclude %{_datadir}/keymaps/i386/qwertz/de-latin1.map.gz
%exclude %{_datadir}/keymaps/i386/qwertz/de.map.gz
%exclude %{_datadir}/keymaps/i386/include
%exclude %{_datadir}/keymaps/include
%{_mandir}
%exclude %{_mandir}/man1/loadkeys.1.gz
%exclude %{_mandir}/man8/setkeycodes.8.gz
%exclude %{_mandir}/man8/setfont.8.gz
%{_datadir}/unimaps

%files doc
%{docdir}/html
